## ceph-16.2.1.tar.gz

=== src/librbd/CMakeLists.txt ===
if(Boost_VERSION VERSION_GREATER_EQUAL 1.74)
  add_definitions(-DBOOST_ASIO_USE_TS_EXECUTOR_AS_DEFAULT)
endif()

set(librbd_types_srcs
  journal/Types.cc
  mirroring_watcher/Types.cc
  trash_watcher/Types.cc
  watcher/Types.cc
  WatchNotifyTypes.cc)

if(WITH_RBD_RWL OR WITH_RBD_SSD_CACHE)
 list(APPEND librbd_types_srcs cache/pwl/Types.cc)
endif()

add_library(rbd_types STATIC
  ${librbd_types_srcs})

if (WITH_RBD_RWL)
  target_link_libraries(rbd_types
    PUBLIC pmem::pmemobj)
endif()

set(librbd_internal_srcs
  AsioEngine.cc
  AsyncObjectThrottle.cc
  AsyncRequest.cc
  ConfigWatcher.cc
  DeepCopyRequest.cc
  ExclusiveLock.cc
  ImageCtx.cc
  ImageState.cc
  ImageWatcher.cc
  internal.cc
  Journal.cc
  LibrbdAdminSocketHook.cc
  ManagedLock.cc
  MirroringWatcher.cc
  ObjectMap.cc
  Operations.cc
  PluginRegistry.cc
  TrashWatcher.cc
  Utils.cc
  Watcher.cc
  api/Config.cc
  api/DiffIterate.cc
  api/Group.cc
  api/Image.cc
  api/Io.cc
  api/Migration.cc
  api/Mirror.cc
  api/Namespace.cc
  api/Pool.cc
  api/PoolMetadata.cc
  api/Snapshot.cc
  api/Trash.cc
  api/Utils.cc
  asio/ContextWQ.cc
  cache/ImageWriteback.cc
  cache/ObjectCacherObjectDispatch.cc
  cache/ObjectCacherWriteback.cc
  cache/WriteAroundObjectDispatch.cc
  crypto/BlockCrypto.cc
  crypto/CryptoContextPool.cc
  crypto/CryptoImageDispatch.cc
  crypto/CryptoObjectDispatch.cc
  crypto/FormatRequest.cc
  crypto/LoadRequest.cc
  crypto/ShutDownCryptoRequest.cc
  crypto/Utils.cc
  crypto/openssl/DataCryptor.cc
  deep_copy/ImageCopyRequest.cc
  deep_copy/MetadataCopyRequest.cc
  deep_copy/ObjectCopyRequest.cc
  deep_copy/SetHeadRequest.cc
  deep_copy/SnapshotCopyRequest.cc
  deep_copy/SnapshotCreateRequest.cc
  deep_copy/Utils.cc
  exclusive_lock/AutomaticPolicy.cc
  exclusive_lock/ImageDispatch.cc
  exclusive_lock/PreAcquireRequest.cc
  exclusive_lock/PostAcquireRequest.cc
  exclusive_lock/PreReleaseRequest.cc
  exclusive_lock/StandardPolicy.cc
  image/AttachChildRequest.cc
  image/AttachParentRequest.cc
  image/CloneRequest.cc
  image/CloseRequest.cc
  image/CreateRequest.cc
  image/DetachChildRequest.cc
  image/DetachParentRequest.cc
  image/GetMetadataRequest.cc
  image/ListWatchersRequest.cc
  image/OpenRequest.cc
  image/PreRemoveRequest.cc
  image/RefreshParentRequest.cc
  image/RefreshRequest.cc
  image/RemoveRequest.cc
  image/SetFlagsRequest.cc
  image/SetSnapRequest.cc
  image/ValidatePoolRequest.cc
  image_watcher/NotifyLockOwner.cc
  io/AioCompletion.cc
  io/AsyncOperation.cc
  io/CopyupRequest.cc
  io/FlushTracker.cc
  io/ImageDispatch.cc
  io/ImageDispatchSpec.cc
  io/ImageDispatcher.cc
  io/ImageRequest.cc
  io/ObjectDispatch.cc
  io/ObjectDispatchSpec.cc
  io/ObjectDispatcher.cc
  io/ObjectRequest.cc
  io/QosImageDispatch.cc
  io/QueueImageDispatch.cc
  io/ReadResult.cc
  io/RefreshImageDispatch.cc
  io/SimpleSchedulerObjectDispatch.cc
  io/Types.cc
  io/Utils.cc
  io/WriteBlockImageDispatch.cc
  journal/CreateRequest.cc
  journal/DemoteRequest.cc
  journal/ObjectDispatch.cc
  journal/OpenRequest.cc
  journal/PromoteRequest.cc
  journal/RemoveRequest.cc
  journal/Replay.cc
  journal/ResetRequest.cc
  journal/StandardPolicy.cc
  journal/Utils.cc
  managed_lock/AcquireRequest.cc
  managed_lock/BreakRequest.cc
  managed_lock/GetLockerRequest.cc
  managed_lock/ReacquireRequest.cc
  managed_lock/ReleaseRequest.cc
  managed_lock/Utils.cc
  migration/FileStream.cc
  migration/HttpClient.cc
  migration/HttpStream.cc
  migration/ImageDispatch.cc
  migration/NativeFormat.cc
  migration/OpenSourceImageRequest.cc
  migration/QCOWFormat.cc
  migration/RawFormat.cc
  migration/RawSnapshot.cc
  migration/S3Stream.cc
  migration/SourceSpecBuilder.cc
  migration/Utils.cc
  mirror/DemoteRequest.cc
  mirror/DisableRequest.cc
  mirror/EnableRequest.cc
  mirror/GetInfoRequest.cc
  mirror/GetStatusRequest.cc
  mirror/GetUuidRequest.cc
  mirror/ImageRemoveRequest.cc
  mirror/ImageStateUpdateRequest.cc
  mirror/PromoteRequest.cc
  mirror/snapshot/CreateNonPrimaryRequest.cc
  mirror/snapshot/CreatePrimaryRequest.cc
  mirror/snapshot/DemoteRequest.cc
  mirror/snapshot/GetImageStateRequest.cc
  mirror/snapshot/ImageMeta.cc
  mirror/snapshot/PromoteRequest.cc
  mirror/snapshot/RemoveImageStateRequest.cc
  mirror/snapshot/SetImageStateRequest.cc
  mirror/snapshot/Types.cc
  mirror/snapshot/UnlinkPeerRequest.cc
  mirror/snapshot/Utils.cc
  mirror/snapshot/WriteImageStateRequest.cc
  object_map/CreateRequest.cc
  object_map/DiffRequest.cc
  object_map/InvalidateRequest.cc
  object_map/LockRequest.cc
  object_map/RefreshRequest.cc
  object_map/RemoveRequest.cc
  object_map/Request.cc
  object_map/ResizeRequest.cc
  object_map/SnapshotCreateRequest.cc
  object_map/SnapshotRemoveRequest.cc
  object_map/SnapshotRollbackRequest.cc
  object_map/UnlockRequest.cc
  object_map/UpdateRequest.cc
  operation/DisableFeaturesRequest.cc
  operation/EnableFeaturesRequest.cc
  operation/FlattenRequest.cc
  operation/MetadataRemoveRequest.cc
  operation/MetadataSetRequest.cc
  operation/MigrateRequest.cc
  operation/ObjectMapIterate.cc
  operation/RebuildObjectMapRequest.cc
  operation/RenameRequest.cc
  operation/Request.cc
  operation/ResizeRequest.cc
  operation/SnapshotCreateRequest.cc
  operation/SnapshotProtectRequest.cc
  operation/SnapshotRemoveRequest.cc
  operation/SnapshotRenameRequest.cc
  operation/SnapshotRollbackRequest.cc
  operation/SnapshotUnprotectRequest.cc
  operation/SnapshotLimitRequest.cc
  operation/SparsifyRequest.cc
  operation/TrimRequest.cc
  plugin/Api.cc
  trash/MoveRequest.cc
  trash/RemoveRequest.cc
  watcher/Notifier.cc
  watcher/RewatchRequest.cc
  ${CMAKE_SOURCE_DIR}/src/common/ContextCompletion.cc)

if(WITH_EVENTTRACE)
  list(APPEND librbd_internal_srcs ../common/EventTrace.cc)
endif()

if(LINUX AND HAVE_LIBCRYPTSETUP)
  list(APPEND librbd_internal_srcs
          crypto/luks/EncryptionFormat.cc
          crypto/luks/Header.cc
          crypto/luks/FormatRequest.cc
          crypto/luks/LoadRequest.cc)
endif()

add_library(rbd_api STATIC librbd.cc)
add_library(rbd_internal STATIC
  ${librbd_internal_srcs}
  $<TARGET_OBJECTS:rados_snap_set_diff_obj>)
if(WITH_LTTNG)
  # librbd.cc includes tracing/librbd.h
  add_dependencies(rbd_api librbd-tp)
  # io/AioCompletion.cc includes tracing/librbd.h
  add_dependencies(rbd_internal librbd-tp)
endif()
if(WITH_EVENTTRACE)
  add_dependencies(rbd_internal eventtrace_tp)
endif()
target_link_libraries(rbd_internal PRIVATE
  osdc rbd_types
  OpenSSL::SSL)
target_include_directories(rbd_internal PRIVATE ${OPENSSL_INCLUDE_DIR})
if(LINUX AND HAVE_LIBCRYPTSETUP)
  target_include_directories(rbd_internal PRIVATE ${LIBCRYPTSETUP_INCLUDE_DIR})
  target_link_libraries(rbd_internal PRIVATE ${LIBCRYPTSETUP_LIBRARIES})
endif()

add_custom_target(librbd_plugins)
set(librbd_plugins_dir ${CEPH_INSTALL_PKGLIBDIR}/librbd)

set(rbd_plugin_parent_cache_srcs
  cache/ParentCacheObjectDispatch.cc
  plugin/ParentCache.cc)
add_library(librbd_plugin_parent_cache SHARED
  ${rbd_plugin_parent_cache_srcs})
target_link_libraries(librbd_plugin_parent_cache PRIVATE
  ceph_immutable_object_cache_lib ceph-common librbd
  libneorados
  librados)
set_target_properties(librbd_plugin_parent_cache PROPERTIES
  OUTPUT_NAME ceph_librbd_parent_cache
  VERSION 1.0.0
  SOVERSION 1)
install(TARGETS librbd_plugin_parent_cache DESTINATION ${librbd_plugins_dir})
add_dependencies(librbd_plugins librbd_plugin_parent_cache)

if(WITH_RBD_RWL OR WITH_RBD_SSD_CACHE)
  set(rbd_plugin_pwl_srcs
    cache/WriteLogImageDispatch.cc
    cache/pwl/AbstractWriteLog.cc
    cache/pwl/DiscardRequest.cc
    cache/pwl/ImageCacheState.cc
    cache/pwl/InitRequest.cc
    cache/pwl/LogEntry.cc
    cache/pwl/LogMap.cc
    cache/pwl/LogOperation.cc
    cache/pwl/Request.cc
    cache/pwl/ShutdownRequest.cc
    cache/pwl/SyncPoint.cc
    cache/pwl/Types.cc
    plugin/WriteLogImageCache.cc)

    if(WITH_RBD_SSD_CACHE)
      set(rbd_plugin_pwl_srcs
        ${rbd_plugin_pwl_srcs}
        cache/pwl/ssd/LogEntry.cc
        cache/pwl/ssd/LogOperation.cc
        cache/pwl/ssd/ReadRequest.cc
        cache/pwl/ssd/Request.cc
        cache/pwl/ssd/WriteLog.cc)
    endif()
    if(WITH_RBD_RWL)
      set(rbd_plugin_pwl_srcs
        ${rbd_plugin_pwl_srcs}
        cache/pwl/rwl/WriteLog.cc
        cache/pwl/rwl/LogEntry.cc
        cache/pwl/rwl/LogOperation.cc
        cache/pwl/rwl/ReadRequest.cc
        cache/pwl/rwl/Request.cc)
    endif()

  add_library(librbd_plugin_pwl_cache SHARED
    ${rbd_plugin_pwl_srcs})
  target_link_libraries(librbd_plugin_pwl_cache PRIVATE
    blk
    ceph-common
    cls_rbd_client
    libneorados
    librados
    StdFilesystem::filesystem)

  if(WITH_RBD_RWL)
    target_link_libraries(librbd_plugin_pwl_cache
      PUBLIC pmem::pmemobj
      PRIVATE pmem::pmem)
  endif()

  set_target_properties(librbd_plugin_pwl_cache PROPERTIES
    OUTPUT_NAME ceph_librbd_pwl_cache
    VERSION 1.0.0
    SOVERSION 1)
  install(TARGETS librbd_plugin_pwl_cache DESTINATION ${librbd_plugins_dir})
  add_dependencies(librbd_plugins librbd_plugin_pwl_cache)
endif()

add_library(librbd ${CEPH_SHARED}
  librbd.cc)
if(WITH_LTTNG)
  add_dependencies(librbd librbd-tp)
endif()

target_link_libraries(librbd PRIVATE
  rbd_internal
  rbd_types
  journal
  cls_rbd_client
  cls_lock_client
  cls_journal_client
  libneorados
  librados
  ceph-common
  pthread
  ${CMAKE_DL_LIBS}
  ${EXTRALIBS} ${GSSAPI_LIBRARIES})
if(HAVE_UDEV)
  target_link_libraries(librbd PRIVATE
    udev)
endif()
if(ENABLE_SHARED)
  set_target_properties(librbd PROPERTIES
    OUTPUT_NAME rbd
    VERSION 1.16.0
    SOVERSION 1
    CXX_VISIBILITY_PRESET hidden
    VISIBILITY_INLINES_HIDDEN ON)
    if(NOT APPLE AND NOT WIN32)
      set_property(TARGET librbd APPEND_STRING PROPERTY
        LINK_FLAGS " -Wl,--exclude-libs,ALL")
    endif()
endif(ENABLE_SHARED)
install(TARGETS librbd DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/rgw/CMakeLists.txt ===
if(Boost_VERSION VERSION_GREATER_EQUAL 1.74)
  add_definitions(-DBOOST_ASIO_USE_TS_EXECUTOR_AS_DEFAULT)
endif()

add_custom_target(civetweb_h
  COMMAND ${CMAKE_COMMAND} -E make_directory
  "${CMAKE_BINARY_DIR}/src/include/civetweb"
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
  "${CMAKE_SOURCE_DIR}/src/civetweb/include/civetweb.h"
  "${CMAKE_BINARY_DIR}/src/include/civetweb"
  COMMENT "keep civetweb.h up-to-date")

find_program(GPERF gperf)
if(NOT GPERF)
  message(FATAL_ERROR "Can't find gperf")
endif()
function(gperf_generate input output)
  add_custom_command(
    OUTPUT ${output}
    COMMAND ${GPERF} ${input} | sed "s/register //g" > ${output}
    DEPENDS ${input}
    COMMENT "Generate ${output}"
    )
endfunction()

find_package(ICU 52.0 COMPONENTS uc REQUIRED)

set(librgw_common_srcs
  services/svc_finisher.cc
  services/svc_bi_rados.cc
  services/svc_bilog_rados.cc
  services/svc_bucket.cc
  services/svc_bucket_sobj.cc
  services/svc_bucket_sync_sobj.cc
  services/svc_cls.cc
  services/svc_config_key_rados.cc
  services/svc_mdlog.cc
  services/svc_meta.cc
  services/svc_meta_be.cc
  services/svc_meta_be_otp.cc
  services/svc_meta_be_sobj.cc
  services/svc_notify.cc
  services/svc_otp.cc
  services/svc_quota.cc
  services/svc_sync_modules.cc
  services/svc_rados.cc
  services/svc_sys_obj.cc
  services/svc_sys_obj_cache.cc
  services/svc_sys_obj_core.cc
  services/svc_tier_rados.cc
  services/svc_user.cc
  services/svc_user_rados.cc
  services/svc_zone.cc
  services/svc_zone_utils.cc
  rgw_service.cc
  rgw_acl.cc
  rgw_acl_s3.cc
  rgw_acl_swift.cc
  rgw_aio.cc
  rgw_aio_throttle.cc
  rgw_auth.cc
  rgw_auth_s3.cc
  rgw_arn.cc
  rgw_basic_types.cc
  rgw_bucket.cc
  rgw_bucket_layout.cc
  rgw_bucket_sync.cc
  rgw_cache.cc
  rgw_common.cc
  rgw_compression.cc
  rgw_etag_verifier.cc
  rgw_cors.cc
  rgw_cors_s3.cc
  rgw_dencoder.cc
  rgw_env.cc
  rgw_es_query.cc
  rgw_formats.cc
  rgw_gc.cc
  rgw_gc_log.cc
  rgw_http_client.cc
  rgw_json_enc.cc
  rgw_keystone.cc
  rgw_ldap.cc
  rgw_lc.cc
  rgw_lc_s3.cc
  rgw_metadata.cc
  rgw_multi.cc
  rgw_multi_del.cc
  rgw_obj_manifest.cc
  rgw_pubsub.cc
  rgw_sync.cc
  rgw_data_sync.cc
  rgw_sync_counters.cc
  rgw_sync_error_repo.cc
  rgw_sync_module.cc
  rgw_sync_module_aws.cc
  rgw_sync_module_es.cc
  rgw_sync_module_es_rest.cc
  rgw_sync_module_log.cc
  rgw_sync_module_pubsub.cc
  rgw_sync_policy.cc
  rgw_pubsub_push.cc
  rgw_notify.cc
  rgw_notify_event_type.cc
  rgw_sync_module_pubsub_rest.cc
  rgw_sync_trace.cc
  rgw_trim_bilog.cc
  rgw_trim_datalog.cc
  rgw_trim_mdlog.cc
  rgw_period_history.cc
  rgw_period_puller.cc
  rgw_reshard.cc
  rgw_coroutine.cc
  rgw_cr_rados.cc
  rgw_cr_rest.cc
  rgw_cr_tools.cc
  rgw_object_expirer_core.cc
  rgw_op.cc
  rgw_otp.cc
  rgw_policy_s3.cc
  rgw_public_access.cc
  rgw_putobj.cc
  rgw_putobj_processor.cc
  rgw_quota.cc
  rgw_rados.cc
  rgw_resolve.cc
  rgw_rest.cc
  rgw_rest_client.cc
  rgw_rest_conn.cc
  rgw_rest_log.cc
  rgw_rest_metadata.cc
  rgw_rest_pubsub.cc
  rgw_rest_pubsub_common.cc
  rgw_rest_realm.cc
  rgw_rest_role.cc
  rgw_rest_s3.cc
  rgw_role.cc
  rgw_sal.cc
  rgw_sal_rados.cc
  rgw_string.cc
  rgw_tag.cc
  rgw_tag_s3.cc
  rgw_tools.cc
  rgw_user.cc
  rgw_website.cc
  rgw_xml.cc
  rgw_xml_enc.cc
  rgw_torrent.cc
  rgw_crypt.cc
  rgw_crypt_sanitize.cc
  rgw_iam_policy.cc
  rgw_rest_user_policy.cc
  rgw_zone.cc
  rgw_sts.cc
  rgw_rest_sts.cc
  rgw_perf_counters.cc
  rgw_rest_oidc_provider.cc
  rgw_rest_iam.cc
  rgw_object_lock.cc
  rgw_kms.cc
  rgw_kmip_client.cc
  rgw_url.cc
  rgw_oidc_provider
  rgw_datalog.cc
  cls_fifo_legacy.cc
  rgw_lua_utils.cc
  rgw_lua.cc
  rgw_lua_request.cc)

if(WITH_RADOSGW_AMQP_ENDPOINT)
  list(APPEND librgw_common_srcs rgw_amqp.cc)
endif()
if(WITH_RADOSGW_KAFKA_ENDPOINT)
  list(APPEND librgw_common_srcs rgw_kafka.cc)
endif()

add_library(rgw_common OBJECT ${librgw_common_srcs})

target_include_directories(rgw_common SYSTEM PUBLIC "services")
target_include_directories(rgw_common PUBLIC "${CMAKE_SOURCE_DIR}/src/dmclock/support/src")
target_include_directories(rgw_common PUBLIC "${CMAKE_SOURCE_DIR}/src/fmt/include")
target_include_directories(rgw_common PUBLIC "${CMAKE_SOURCE_DIR}/src/rgw")
target_include_directories(rgw_common PRIVATE "${LUA_INCLUDE_DIR}")
target_include_directories(rgw_common SYSTEM PRIVATE "${ICU_INCLUDE_DIRS}")


set(librgw_kmip_srcs
  rgw_kmip_client_impl.cc)

add_library(rgw_kmip OBJECT ${librgw_kmip_srcs})

target_include_directories(rgw_kmip PRIVATE "${CMAKE_SOURCE_DIR}/src/libkmip")

target_include_directories(rgw_common PRIVATE
  $<TARGET_PROPERTY:spawn,INTERFACE_INCLUDE_DIRECTORIES>)
target_compile_definitions(rgw_common PRIVATE
  $<TARGET_PROPERTY:spawn,INTERFACE_COMPILE_DEFINITIONS>)
target_include_directories(rgw_kmip PRIVATE
  $<TARGET_PROPERTY:spawn,INTERFACE_INCLUDE_DIRECTORIES>)
target_compile_definitions(rgw_kmip PRIVATE
  $<TARGET_PROPERTY:spawn,INTERFACE_COMPILE_DEFINITIONS>)

if(WITH_LTTNG)
  # rgw/rgw_op.cc includes "tracing/rgw_op.h"
  # rgw/rgw_rados.cc includes "tracing/rgw_rados.h"
  add_dependencies(rgw_common rgw_op-tp rgw_rados-tp)
endif()

if(WITH_JAEGER)
  add_dependencies(rgw_common jaegertracing::libjaegertracing)
endif()

set(rgw_a_srcs
  rgw_auth_keystone.cc
  rgw_client_io.cc
  rgw_frontend.cc
  rgw_http_client_curl.cc
  rgw_loadgen.cc
  rgw_log.cc
  rgw_period_pusher.cc
  rgw_realm_reloader.cc
  rgw_realm_watcher.cc
  rgw_os_lib.cc
  rgw_process.cc
  rgw_rest_bucket.cc
  rgw_rest_config.cc
  rgw_rest_log.cc
  rgw_rest_metadata.cc
  rgw_rest_realm.cc
  rgw_rest_swift.cc
  rgw_rest_usage.cc
  rgw_rest_user.cc
  rgw_swift_auth.cc
  rgw_usage.cc
  rgw_opa.cc
  rgw_sts.cc
  rgw_rest_sts.cc)

gperf_generate(${CMAKE_SOURCE_DIR}/src/rgw/rgw_iam_policy_keywords.gperf
  rgw_iam_policy_keywords.frag.cc)
set_source_files_properties(rgw_iam_policy.cc PROPERTIES
  OBJECT_DEPENDS ${CMAKE_BINARY_DIR}/src/rgw/rgw_iam_policy_keywords.frag.cc
  COMPILE_FLAGS -I${CMAKE_BINARY_DIR}/src/rgw)


if (WITH_RADOSGW_FCGI_FRONTEND)
  list(APPEND rgw_a_srcs rgw_fcgi.cc)
endif()

add_library(rgw_a STATIC
    ${rgw_a_srcs}
    $<TARGET_OBJECTS:rgw_common>)

add_dependencies(rgw_a civetweb_h)

target_compile_definitions(rgw_a PUBLIC "-DCLS_CLIENT_HIDE_IOCTX")
target_include_directories(rgw_a PUBLIC "${CMAKE_SOURCE_DIR}/src/dmclock/support/src")
target_include_directories(rgw_a SYSTEM PUBLIC "../rapidjson/include")
target_include_directories(rgw_a SYSTEM PUBLIC "${CMAKE_SOURCE_DIR}/src/rgw")

if(WITH_RADOSGW_AMQP_ENDPOINT)
  find_package(RabbitMQ REQUIRED)
endif()
if(WITH_RADOSGW_KAFKA_ENDPOINT)
  find_package(RDKafka 0.9.2 REQUIRED)
endif()

target_link_libraries(rgw_a
  PRIVATE
  librados cls_otp_client cls_lock_client cls_rgw_client cls_refcount_client
  cls_log_client cls_timeindex_client cls_version_client cls_cmpomap_client
  cls_user_client cls_rgw_gc_client cls_2pc_queue_client ceph-common common_utf8 global
  ${CURL_LIBRARIES}
  ${EXPAT_LIBRARIES}
  ${OPENLDAP_LIBRARIES} ${CRYPTO_LIBS}
  ICU::uc
  OATH::OATH)

if(WITH_CURL_OPENSSL)
  # used by rgw_http_client_curl.cc
  target_link_libraries(rgw_a PRIVATE OpenSSL::Crypto)
endif()

target_link_libraries(rgw_a PRIVATE ${LUA_LIBRARIES})
target_link_libraries(rgw_a PUBLIC spawn)

set(rgw_libs rgw_a)
if(WITH_RADOSGW_AMQP_ENDPOINT)
  # used by rgw_amqp.cc
  list(APPEND rgw_libs RabbitMQ::RabbitMQ)
  list(APPEND rgw_libs OpenSSL::SSL)
endif()
if(WITH_RADOSGW_KAFKA_ENDPOINT)
  # used by rgw_kafka.cc
  list(APPEND rgw_libs RDKafka::RDKafka)
endif()

list(APPEND rgw_libs ${LUA_LIBRARIES})

if(WITH_RADOSGW_LUA_PACKAGES)
  list(APPEND rgw_libs Boost::filesystem)
endif()

set(rgw_schedulers_srcs
  rgw_dmclock_scheduler_ctx.cc
  rgw_dmclock_sync_scheduler.cc)
set(radosgw_srcs
  rgw_loadgen_process.cc
  rgw_civetweb.cc
  rgw_civetweb_frontend.cc
  rgw_civetweb_log.cc)
if (WITH_RADOSGW_FCGI_FRONTEND)
  list(APPEND radosgw_srcs rgw_fcgi_process.cc)
endif()

if(WITH_RADOSGW_BEAST_FRONTEND)
  list(APPEND radosgw_srcs
    rgw_asio_client.cc
    rgw_asio_frontend.cc)
  list(APPEND rgw_schedulers_srcs
    rgw_dmclock_async_scheduler.cc)
endif()

add_library(rgw_schedulers STATIC ${rgw_schedulers_srcs})
target_link_libraries(rgw_schedulers
  PUBLIC dmclock::dmclock)

add_library(radosgw SHARED ${radosgw_srcs} ${rgw_a_srcs} rgw_main.cc
  $<TARGET_OBJECTS:rgw_kmip>
  $<TARGET_OBJECTS:civetweb_common_objs>)

add_dependencies(radosgw civetweb_h)

target_compile_definitions(radosgw PUBLIC "-DCLS_CLIENT_HIDE_IOCTX")
target_include_directories(radosgw PUBLIC "${CMAKE_SOURCE_DIR}/src/dmclock/support/src")
target_include_directories(radosgw SYSTEM PUBLIC "../rapidjson/include")

target_link_libraries(radosgw
  PRIVATE ${rgw_libs} rgw_schedulers kmip
  PUBLIC dmclock::dmclock
)
if(WITH_RADOSGW_BEAST_FRONTEND)
  target_link_libraries(rgw_schedulers PUBLIC spawn)
  if(WITH_RADOSGW_BEAST_OPENSSL)
    # used by rgw_asio_frontend.cc
    target_link_libraries(radosgw PRIVATE OpenSSL::SSL)
  endif()
endif()
set_target_properties(radosgw PROPERTIES OUTPUT_NAME radosgw VERSION 2.0.0
  SOVERSION 2)
install(TARGETS radosgw DESTINATION ${CMAKE_INSTALL_LIBDIR})

add_executable(radosgwd radosgw.cc)
target_link_libraries(radosgwd radosgw librados
  cls_rgw_client cls_otp_client cls_lock_client cls_refcount_client
  cls_log_client cls_timeindex_client neorados_cls_fifo
  cls_version_client cls_user_client
  global
  ${FCGI_LIBRARY} ${LIB_RESOLV}
  ${CURL_LIBRARIES} ${EXPAT_LIBRARIES} ${BLKID_LIBRARIES}
  ${ALLOC_LIBS})
set_target_properties(radosgwd PROPERTIES OUTPUT_NAME radosgw)
install(TARGETS radosgwd DESTINATION bin)

set(radosgw_admin_srcs
  rgw_admin.cc
  rgw_sync_checkpoint.cc
  rgw_orphan.cc)
add_executable(radosgw-admin ${radosgw_admin_srcs})
target_link_libraries(radosgw-admin ${rgw_libs} librados
  cls_rgw_client cls_otp_client cls_lock_client cls_refcount_client
  cls_log_client cls_timeindex_client neorados_cls_fifo
  cls_version_client cls_user_client
  global ${FCGI_LIBRARY} ${LIB_RESOLV}
  ${CURL_LIBRARIES} ${EXPAT_LIBRARIES} ${BLKID_LIBRARIES})
install(TARGETS radosgw-admin DESTINATION bin)

set(radosgw_es_srcs
  rgw_es_main.cc)
add_executable(radosgw-es ${radosgw_es_srcs})
target_link_libraries(radosgw-es ${rgw_libs} librados
  cls_rgw_client cls_otp_client cls_lock_client cls_refcount_client
  cls_log_client cls_timeindex_client neorados_cls_fifo
  cls_version_client cls_user_client
  global ${FCGI_LIBRARY} ${LIB_RESOLV}
  ${CURL_LIBRARIES} ${EXPAT_LIBRARIES} ${BLKID_LIBRARIES})
install(TARGETS radosgw-es DESTINATION bin)

set(radosgw_token_srcs
  rgw_token.cc)
add_executable(radosgw-token ${radosgw_token_srcs})
target_link_libraries(radosgw-token librados
  global ${ALLOC_LIBS})
install(TARGETS radosgw-token DESTINATION bin)

set(radosgw_object_expirer_srcs
  rgw_object_expirer.cc)
add_executable(radosgw-object-expirer ${radosgw_object_expirer_srcs})
target_link_libraries(radosgw-object-expirer ${rgw_libs} librados
  cls_rgw_client cls_otp_client cls_lock_client cls_refcount_client
  cls_log_client cls_timeindex_client neorados_cls_fifo
  cls_version_client cls_user_client
  global ${FCGI_LIBRARY} ${LIB_RESOLV}
  ${CURL_LIBRARIES} ${EXPAT_LIBRARIES})
install(TARGETS radosgw-object-expirer DESTINATION bin)

set(librgw_srcs
  librgw.cc
  rgw_file.cc)
add_library(rgw SHARED ${librgw_srcs})
target_link_libraries(rgw
  PRIVATE
  ${rgw_libs}
  librados
  cls_rgw_client
  cls_otp_client
  cls_lock_client
  cls_refcount_client
  cls_log_client
  cls_timeindex_client
  neorados_cls_fifo
  cls_version_client
  cls_user_client
  global
  ${LIB_RESOLV}
  ${CURL_LIBRARIES}
  ${EXPAT_LIBRARIES}
  PUBLIC
  dmclock::dmclock)

if(WITH_RADOSGW_AMQP_ENDPOINT)
  target_link_libraries(rgw PRIVATE RabbitMQ::RabbitMQ)
  target_link_libraries(rgw PRIVATE OpenSSL::SSL)
endif()

if(WITH_RADOSGW_KAFKA_ENDPOINT)
  target_link_libraries(rgw PRIVATE RDKafka::RDKafka)
endif()

target_link_libraries(rgw PRIVATE ${LUA_LIBRARIES})

set_target_properties(rgw PROPERTIES OUTPUT_NAME rgw VERSION 2.0.0
  SOVERSION 2)

=== src/test/common/CMakeLists.txt ===
if(NOT WIN32)
# get_command_descriptions
# libmon not currently available on Windows.
add_executable(get_command_descriptions
  get_command_descriptions.cc
  $<TARGET_OBJECTS:common_texttable_obj>
  )
target_link_libraries(get_command_descriptions
  mon
  global
  ${LEVELDB_LIBRARIES}
  ${EXTRALIBS}
  ${BLKID_LIBRARIES}
  ${CMAKE_DL_LIBS}
  )
endif(NOT WIN32)

# Though FreeBSD has blkdev support, the unittests' mocks only work in Linux
if(HAVE_BLKID AND LINUX)
  # unittest_blkdev
  add_executable(unittest_blkdev
    test_blkdev.cc)
  add_ceph_unittest(unittest_blkdev ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unittest_blkdev)
  target_link_libraries(unittest_blkdev global ${BLKID_LIBRARIES})
endif()

# unittest_lockdep
add_executable(unittest_lockdep
  test_lockdep.cc)
add_ceph_unittest(unittest_lockdep)
target_link_libraries(unittest_lockdep ceph-common)

# unittest_counter
add_executable(unittest_counter
  test_counter.cc)
add_ceph_unittest(unittest_counter)
target_link_libraries(unittest_counter ceph-common)

# FreeBSD only has shims to support NUMA, no functional code.
if(LINUX)
# unittest_numa
add_executable(unittest_numa
  test_numa.cc
  )
add_ceph_unittest(unittest_numa)
target_link_libraries(unittest_numa ceph-common)
endif()

# unittest_bloom_filter
add_executable(unittest_bloom_filter
  test_bloom_filter.cc
  )
add_ceph_unittest(unittest_bloom_filter)
target_link_libraries(unittest_bloom_filter ceph-common)

# unittest_histogram
add_executable(unittest_histogram
  histogram.cc
  )
add_ceph_unittest(unittest_histogram)
target_link_libraries(unittest_histogram ceph-common)

# unittest_prioritized_queue
add_executable(unittest_prioritized_queue
  test_prioritized_queue.cc
  )
target_link_libraries(unittest_prioritized_queue ceph-common)
add_ceph_unittest(unittest_prioritized_queue)

if(NOT WIN32)
# unittest_mclock_priority_queue
add_executable(unittest_mclock_priority_queue
  test_mclock_priority_queue.cc
  )
add_ceph_unittest(unittest_mclock_priority_queue)
target_link_libraries(unittest_mclock_priority_queue
  ceph-common
  dmclock::dmclock)
endif(NOT WIN32)

# unittest_str_map
add_executable(unittest_str_map
  test_str_map.cc
  )
add_ceph_unittest(unittest_str_map)
target_link_libraries(unittest_str_map ceph-common)

# unittest_json_formattable
add_executable(unittest_json_formattable
  test_json_formattable.cc
  )
add_ceph_unittest(unittest_json_formattable ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unittest_json_formattable)
# add_dependencies(unittest_json_formattable ceph-common)
target_link_libraries(unittest_json_formattable ceph-common global ${BLKID_LIBRARIES})

# unittest_json_formatter
add_executable(unittest_json_formatter
  test_json_formatter.cc
  )
add_ceph_unittest(unittest_json_formatter ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unittest_json_formatter)
# add_dependencies(unittest_json_formatter ceph-common)
target_link_libraries(unittest_json_formatter ceph-common global ${BLKID_LIBRARIES})

# unittest_sharedptr_registry
add_executable(unittest_sharedptr_registry
  test_sharedptr_registry.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_sharedptr_registry)
target_link_libraries(unittest_sharedptr_registry global)

# unittest_shared_cache
add_executable(unittest_shared_cache
  test_shared_cache.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_shared_cache)
target_link_libraries(unittest_shared_cache global)

# unittest_sloppy_crc_map
add_executable(unittest_sloppy_crc_map
  test_sloppy_crc_map.cc
  )
add_ceph_unittest(unittest_sloppy_crc_map)
target_link_libraries(unittest_sloppy_crc_map global)

# unittest_time
add_executable(unittest_time
  test_time.cc
  ${CMAKE_SOURCE_DIR}/src/common/ceph_time.cc
  )
add_ceph_unittest(unittest_time)
target_link_libraries(unittest_time ceph-common)

# unittest_util
add_executable(unittest_util
  test_util.cc
  ${CMAKE_SOURCE_DIR}/src/common/util.cc
  )
add_ceph_unittest(unittest_util)
target_link_libraries(unittest_util global StdFilesystem::filesystem)

# unittest_random
add_executable(unittest_random
  test_random.cc
  )
add_ceph_unittest(unittest_random)
target_link_libraries(unittest_random Boost::random)

# unittest_throttle
add_executable(unittest_throttle
  Throttle.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_throttle parallel)
target_link_libraries(unittest_throttle global) 

# unittest_lru
add_executable(unittest_lru
  test_lru.cc
  )
add_ceph_unittest(unittest_lru)
target_link_libraries(unittest_lru ceph-common)

# unittest_intrusive_lru
add_executable(unittest_intrusive_lru
  test_intrusive_lru.cc
  )
add_ceph_unittest(unittest_intrusive_lru)
target_link_libraries(unittest_intrusive_lru ceph-common)

# unittest_crc32c
add_executable(unittest_crc32c
  test_crc32c.cc
  )
add_ceph_unittest(unittest_crc32c)
target_link_libraries(unittest_crc32c ceph-common)

# unittest_config
add_executable(unittest_config
  test_config.cc
  test_hostname.cc
  )
add_ceph_unittest(unittest_config)
target_link_libraries(unittest_config ceph-common)

# unittest_context
add_executable(unittest_context
  test_context.cc
  )
add_ceph_unittest(unittest_context)
target_link_libraries(unittest_context ceph-common)

# unittest_safe_io
add_executable(unittest_safe_io
  test_safe_io.cc
  )
add_ceph_unittest(unittest_safe_io)
target_link_libraries(unittest_safe_io ceph-common)

# unittest_url_escape
add_executable(unittest_url_escape
  test_url_escape.cc
  )
add_ceph_unittest(unittest_url_escape)
target_link_libraries(unittest_url_escape ceph-common)

# unittest_pretty_binary
add_executable(unittest_pretty_binary
  test_pretty_binary.cc
  )
add_ceph_unittest(unittest_pretty_binary)
target_link_libraries(unittest_pretty_binary ceph-common)

# unittest_readahead
add_executable(unittest_readahead
  Readahead.cc
  )
add_ceph_unittest(unittest_readahead)
target_link_libraries(unittest_readahead ceph-common)

# unittest_tableformatter
add_executable(unittest_tableformatter
  test_tableformatter.cc
  )
add_ceph_unittest(unittest_tableformatter)
target_link_libraries(unittest_tableformatter ceph-common)

add_executable(unittest_xmlformatter
    test_xmlformatter.cc
    )
add_ceph_unittest(unittest_xmlformatter)
target_link_libraries(unittest_xmlformatter ceph-common)

# unittest_bit_vector
add_executable(unittest_bit_vector
  test_bit_vector.cc
  )
add_ceph_unittest(unittest_bit_vector)
target_link_libraries(unittest_bit_vector ceph-common)

# unittest_interval_map
add_executable(unittest_interval_map
  test_interval_map.cc
)
add_ceph_unittest(unittest_interval_map)
target_link_libraries(unittest_interval_map ceph-common)

# unittest_interval_set
add_executable(unittest_interval_set
  test_interval_set.cc
)
add_ceph_unittest(unittest_interval_set)
target_link_libraries(unittest_interval_set ceph-common GTest::Main)

# unittest_weighted_priority_queue
add_executable(unittest_weighted_priority_queue
  test_weighted_priority_queue.cc
  )
target_link_libraries(unittest_weighted_priority_queue ceph-common)
add_ceph_unittest(unittest_weighted_priority_queue)

# unittest_mutex_debug
add_executable(unittest_mutex_debug
  test_mutex_debug.cc
  )
add_ceph_unittest(unittest_mutex_debug)
target_link_libraries(unittest_mutex_debug ceph-common)

# unittest_shunique_lock
add_executable(unittest_shunique_lock
  test_shunique_lock.cc
  )
add_ceph_unittest(unittest_shunique_lock)
target_link_libraries(unittest_shunique_lock ceph-common)

# unittest_perf_histogram
add_executable(unittest_perf_histogram
  test_perf_histogram.cc
  )
add_ceph_unittest(unittest_perf_histogram)
target_link_libraries(unittest_perf_histogram ceph-common)

# unittest_global_doublefree
if(WITH_CEPHFS)
  add_executable(unittest_global_doublefree
    test_global_doublefree.cc
    )
  add_ceph_unittest(unittest_global_doublefree)
  target_link_libraries(unittest_global_doublefree cephfs librados)
endif(WITH_CEPHFS)

if(NOT WIN32)
add_executable(unittest_dns_resolve
  dns_resolve.cc
  $<TARGET_OBJECTS:unit-main>)
target_link_libraries(unittest_dns_resolve global)
add_ceph_unittest(unittest_dns_resolve)
endif()

add_executable(unittest_back_trace
  test_back_trace.cc)
set_source_files_properties(test_back_trace.cc PROPERTIES
  COMPILE_FLAGS -fno-inline)
add_ceph_unittest(unittest_back_trace)
target_link_libraries(unittest_back_trace ceph-common)

add_executable(unittest_hostname
    test_hostname.cc)
add_ceph_unittest(unittest_hostname)
target_link_libraries(unittest_hostname ceph-common)

add_executable(unittest_iso_8601
    test_iso_8601.cc)
add_ceph_unittest(unittest_iso_8601)
target_link_libraries(unittest_iso_8601 ceph-common)

add_executable(unittest_convenience test_convenience.cc)
add_ceph_unittest(unittest_convenience)

add_executable(unittest_bounded_key_counter
  test_bounded_key_counter.cc
  $<TARGET_OBJECTS:unit-main>)
target_link_libraries(unittest_bounded_key_counter global)
add_ceph_unittest(unittest_bounded_key_counter)

add_executable(unittest_split test_split.cc)
add_ceph_unittest(unittest_split)

add_executable(unittest_static_ptr test_static_ptr.cc)
add_ceph_unittest(unittest_static_ptr)

add_executable(unittest_hobject test_hobject.cc
  $<TARGET_OBJECTS:unit-main>)
target_link_libraries(unittest_hobject global ceph-common)
add_ceph_unittest(unittest_hobject)

add_executable(unittest_async_completion test_async_completion.cc)
add_ceph_unittest(unittest_async_completion)
target_link_libraries(unittest_async_completion ceph-common Boost::system)

add_executable(unittest_async_shared_mutex test_async_shared_mutex.cc)
add_ceph_unittest(unittest_async_shared_mutex)
target_link_libraries(unittest_async_shared_mutex ceph-common Boost::system)

add_executable(unittest_cdc test_cdc.cc
  $<TARGET_OBJECTS:unit-main>)
target_link_libraries(unittest_cdc global ceph-common)
add_ceph_unittest(unittest_cdc)

add_executable(unittest_ceph_timer test_ceph_timer.cc)
add_ceph_unittest(unittest_ceph_timer)


add_executable(unittest_blocked_completion test_blocked_completion.cc)
add_ceph_unittest(unittest_blocked_completion)
target_link_libraries(unittest_blocked_completion Boost::system GTest::GTest)

add_executable(unittest_allocate_unique test_allocate_unique.cc)
add_ceph_unittest(unittest_allocate_unique)

=== src/test/crimson/CMakeLists.txt ===
# the crimson's backfill doesn't need nor use seastar
add_executable(unittest-crimson-backfill
  test_backfill.cc
  ${PROJECT_SOURCE_DIR}/src/auth/Crypto.cc
  ${PROJECT_SOURCE_DIR}/src/crimson/osd/backfill_state.cc
  ${PROJECT_SOURCE_DIR}/src/osd/recovery_types.cc)
add_ceph_unittest(unittest-crimson-backfill)
target_link_libraries(unittest-crimson-backfill crimson GTest::Main)

add_executable(unittest-seastar-buffer
  test_buffer.cc)
add_ceph_test(unittest-seastar-buffer
  unittest-seastar-buffer --memory 256M --smp 1)
target_link_libraries(unittest-seastar-buffer crimson)

add_executable(unittest-seastar-denc
  test_denc.cc)
add_ceph_unittest(unittest-seastar-denc)
target_link_libraries(unittest-seastar-denc crimson GTest::Main)

add_executable(unittest-seastar-socket test_socket.cc)
add_ceph_test(unittest-seastar-socket
  unittest-seastar-socket --memory 256M --smp 2)
target_link_libraries(unittest-seastar-socket crimson)

add_executable(unittest-seastar-messenger test_messenger.cc)
add_ceph_test(unittest-seastar-messenger
  unittest-seastar-messenger --memory 256M --smp 1)
target_link_libraries(unittest-seastar-messenger crimson)

add_executable(test-seastar-messenger-peer test_messenger_peer.cc)
target_link_libraries(test-seastar-messenger-peer ceph-common global ${ALLOC_LIBS})

add_executable(test-seastar-echo
  test_alien_echo.cc)
target_link_libraries(test-seastar-echo crimson)

add_executable(test-async-echo
  test_async_echo.cc)
target_link_libraries(test-async-echo ceph-common global)

add_executable(unittest-seastar-alienstore-thread-pool
  test_alienstore_thread_pool.cc)
add_ceph_test(unittest-seastar-alienstore-thread-pool
  unittest-seastar-alienstore-thread-pool --memory 256M --smp 1)
target_link_libraries(unittest-seastar-alienstore-thread-pool
  crimson-alienstore
  crimson)

add_executable(unittest-seastar-config
  test_config.cc)
add_ceph_test(unittest-seastar-config
  unittest-seastar-config --memory 256M)
target_link_libraries(unittest-seastar-config crimson)

add_executable(unittest-seastar-monc
  test_monc.cc)
target_link_libraries(unittest-seastar-monc crimson)

add_executable(unittest-seastar-perfcounters
  test_perfcounters.cc)
add_ceph_test(unittest-seastar-perfcounters
  unittest-seastar-perfcounters --memory 256M --smp 1)
target_link_libraries(unittest-seastar-perfcounters crimson)

add_executable(unittest-seastar-lru
  test_lru.cc)
add_ceph_unittest(unittest-seastar-lru --memory 256M --smp 1)
target_link_libraries(unittest-seastar-lru crimson GTest::Main)

add_executable(unittest-fixed-kv-node-layout
  test_fixed_kv_node_layout.cc)
add_ceph_unittest(unittest-fixed-kv-node-layout)

add_subdirectory(seastore)

add_library(crimson-gtest STATIC
  gtest_seastar.cc)
target_link_libraries(crimson-gtest crimson-common GTest::GTest)
add_library(crimson::gtest ALIAS crimson-gtest)

add_executable(unittest-seastar-errorator
  test_errorator.cc)
target_link_libraries(
  unittest-seastar-errorator
  crimson::gtest)
add_ceph_unittest(unittest-seastar-errorator)

=== src/test/erasure-code/CMakeLists.txt ===

add_executable(ceph_erasure_code_benchmark 
  ${CMAKE_SOURCE_DIR}/src/erasure-code/ErasureCode.cc
  ceph_erasure_code_benchmark.cc)
target_link_libraries(ceph_erasure_code_benchmark ceph-common Boost::program_options global ${CMAKE_DL_LIBS})
install(TARGETS ceph_erasure_code_benchmark
  DESTINATION bin)

add_executable(ceph_erasure_code_non_regression ceph_erasure_code_non_regression.cc)
target_link_libraries(ceph_erasure_code_non_regression ceph-common Boost::program_options global ${CMAKE_DL_LIBS})

add_library(ec_example SHARED 
  ErasureCodePluginExample.cc
  $<TARGET_OBJECTS:erasure_code_objs>)
target_link_libraries(ec_example pthread ${EXTRALIBS})

add_library(ec_missing_entry_point SHARED ErasureCodePluginMissingEntryPoint.cc)
target_link_libraries(ec_missing_entry_point pthread ${EXTRALIBS})

add_library(ec_missing_version SHARED ErasureCodePluginMissingVersion.cc)
target_link_libraries(ec_missing_version pthread ${EXTRALIBS})

add_library(ec_hangs SHARED ErasureCodePluginHangs.cc)
target_link_libraries(ec_hangs pthread ${EXTRALIBS})

add_library(ec_fail_to_initialize SHARED ErasureCodePluginFailToInitialize.cc)
target_link_libraries(ec_fail_to_initialize pthread ${EXTRALIBS})

add_library(ec_fail_to_register SHARED ErasureCodePluginFailToRegister.cc)
target_link_libraries(ec_fail_to_register pthread ${EXTRALIBS})

# unittest_erasure_code_plugin
add_executable(unittest_erasure_code_plugin
  ${CMAKE_SOURCE_DIR}/src/erasure-code/ErasureCode.cc
  TestErasureCodePlugin.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_erasure_code_plugin)
target_link_libraries(unittest_erasure_code_plugin
  global
  ${CMAKE_DL_LIBS}
  ec_example
  ceph-common
  )
add_dependencies(unittest_erasure_code_plugin
  ec_example
  ec_missing_entry_point
  ec_missing_version
  ec_hangs
  ec_fail_to_initialize
  ec_fail_to_register)

# unittest_erasure_code
add_executable(unittest_erasure_code
  ${CMAKE_SOURCE_DIR}/src/erasure-code/ErasureCode.cc
  TestErasureCode.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_erasure_code)
target_link_libraries(unittest_erasure_code
  global
  ceph-common
  )

# unittest_erasure_code_plugin_jerasure
add_executable(unittest_erasure_code_plugin_jerasure
  TestErasureCodePluginJerasure.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_erasure_code_plugin_jerasure)
target_link_libraries(unittest_erasure_code_plugin_jerasure
  global
  ceph-common)
add_dependencies(unittest_erasure_code_plugin_jerasure
  ec_jerasure)

if(HAVE_NASM_X64_AVX2 OR HAVE_ARMV8_SIMD)

#unittest_erasure_code_isa
add_executable(unittest_erasure_code_isa
  ${CMAKE_SOURCE_DIR}/src/erasure-code/ErasureCode.cc
  TestErasureCodeIsa.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_erasure_code_isa)
target_link_libraries(unittest_erasure_code_isa
  global
  ceph-common
  ec_isa
  erasure_code
  )

#unittest_erasure_code_plugin_isa
add_executable(unittest_erasure_code_plugin_isa
  ${CMAKE_SOURCE_DIR}/src/erasure-code/ErasureCode.cc
  TestErasureCodePluginIsa.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_erasure_code_plugin_isa)
target_link_libraries(unittest_erasure_code_plugin_isa
  global
  ceph-common
  ${CMAKE_DL_LIBS}
  erasure_code
  )
add_dependencies(unittest_erasure_code_plugin_isa
  ec_isa)
endif(HAVE_NASM_X64_AVX2 OR HAVE_ARMV8_SIMD)

# unittest_erasure_code_lrc
add_executable(unittest_erasure_code_lrc
  TestErasureCodeLrc.cc
  $<TARGET_OBJECTS:unit-main>)
add_ceph_unittest(unittest_erasure_code_lrc)
target_link_libraries(unittest_erasure_code_lrc
  global
  ${CMAKE_DL_LIBS}
  ec_lrc
  ceph-common
  )

# unittest_erasure_code_plugin_lrc
add_executable(unittest_erasure_code_plugin_lrc
  TestErasureCodePluginLrc.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_erasure_code_plugin_lrc)
add_dependencies(unittest_erasure_code_plugin_lrc 
  ec_lrc
  ec_jerasure)
target_link_libraries(unittest_erasure_code_plugin_lrc
  global
  ${CMAKE_DL_LIBS}
  ceph-common)

# unittest_erasure_code_plugin_shec
add_executable(unittest_erasure_code_plugin_shec
  TestErasureCodePluginShec.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_erasure_code_plugin_shec)
target_link_libraries(unittest_erasure_code_plugin_shec
  global
  ${CMAKE_DL_LIBS}
  ceph-common)
add_dependencies(unittest_erasure_code_plugin_shec 
  ec_shec)

# unittest_erasure_code_example
add_executable(unittest_erasure_code_example
  ${CMAKE_SOURCE_DIR}/src/erasure-code/ErasureCode.cc
  TestErasureCodeExample.cc
  $<TARGET_OBJECTS:unit-main>
)
add_ceph_unittest(unittest_erasure_code_example)
target_link_libraries(unittest_erasure_code_example
  global
  ${CMAKE_DL_LIBS}
  ceph-common
  erasure_code
  ${UNITTEST_LIBS}
  )

include_directories(SYSTEM ${CMAKE_SOURCE_DIR}/src/erasure-code/jerasure/jerasure/include)
include_directories(SYSTEM ${CMAKE_SOURCE_DIR}/src/erasure-code//jerasure/gf-complete/include)

# unittest_erasure_code_jerasure
add_executable(unittest_erasure_code_jerasure
  TestErasureCodeJerasure.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_erasure_code_jerasure)
target_link_libraries(unittest_erasure_code_jerasure
  global
  ceph-common
  ec_jerasure
  )

include_directories(${CMAKE_SOURCE_DIR}/src/erasure-code/jerasure)
include_directories(${CMAKE_SOURCE_DIR}/src/erasure-code/shec)

# unittest_erasure_code_shec
add_executable(unittest_erasure_code_shec
  TestErasureCodeShec.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_erasure_code_shec)
target_link_libraries(unittest_erasure_code_shec
  global
  ${CMAKE_DL_LIBS}
  ceph-common
  ec_shec
  )

# unittest_erasure_code_shec_all
add_executable(unittest_erasure_code_shec_all
  TestErasureCodeShec_all.cc
  )
add_ceph_unittest(unittest_erasure_code_shec_all parallel)
target_link_libraries(unittest_erasure_code_shec_all
  global
  ${CMAKE_DL_LIBS}
  ceph-common
  ec_shec
  )

# unittest_erasure_code_shec_thread
add_executable(unittest_erasure_code_shec_thread
  TestErasureCodeShec_thread.cc
  $<TARGET_OBJECTS:unit-main>
  )
add_ceph_unittest(unittest_erasure_code_shec_thread)
target_link_libraries(unittest_erasure_code_shec_thread
  global
  ${CMAKE_DL_LIBS}
  ceph-common
  ec_shec
  )


# unittest_erasure_code_shec_arguments
add_executable(unittest_erasure_code_shec_arguments
  TestErasureCodeShec_arguments.cc
  )
add_ceph_unittest(unittest_erasure_code_shec_arguments)
target_link_libraries(unittest_erasure_code_shec_arguments
  global
  ${CMAKE_DL_LIBS}
  ceph-common
  ec_shec
  )

#unitest_erasure_code_clay
add_executable(unittest_erasure_code_clay
  TestErasureCodeClay.cc
  $<TARGET_OBJECTS:unit-main>)
add_ceph_unittest(unittest_erasure_code_clay)
target_link_libraries(unittest_erasure_code_clay
  global
  ${CMAKE_DL_LIBS}
  ${UNITTEST_LIBS}
  ceph-common
  ec_clay
  )

# unittest_erasure_code_plugin_clay
add_executable(unittest_erasure_code_plugin_clay
  TestErasureCodePluginClay.cc
  $<TARGET_OBJECTS:unit-main>)
add_ceph_unittest(unittest_erasure_code_plugin_clay)
add_dependencies(unittest_erasure_code_plugin_clay
  ec_clay)
target_link_libraries(unittest_erasure_code_plugin_clay
  GTest::Main
  global
  ${CMAKE_DL_LIBS}
  ${UNITTEST_LIBS}
  ceph-common)

=== src/boost/libs/histogram/CMakeLists.txt ===
# Copyright Peter Dimov, Hans Dembinski 2018-2019
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

# We support CMake 3.5, but prefer 3.16 policies and behavior
cmake_minimum_required(VERSION 3.5...3.16)

project(boost_histogram VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_histogram INTERFACE)
add_library(Boost::histogram ALIAS boost_histogram)

target_include_directories(boost_histogram INTERFACE include)

target_compile_features(boost_histogram INTERFACE cxx_std_14)

target_link_libraries(boost_histogram
  INTERFACE
    Boost::assert
    Boost::config
    Boost::core
    Boost::mp11
    Boost::throw_exception
    Boost::variant2)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

  # Fetch support files

  message(STATUS "Fetching BoostFetch.cmake")

  file(DOWNLOAD
    "https://raw.githubusercontent.com/boostorg/cmake/develop/include/BoostFetch.cmake"
    "${CMAKE_BINARY_DIR}/fetch_and_include/BoostFetch.cmake"
  )

  include("${CMAKE_BINARY_DIR}/fetch_and_include/BoostFetch.cmake")

  boost_fetch(boostorg/cmake TAG develop NO_ADD_SUBDIR)

  FetchContent_GetProperties(boostorg_cmake)

  list(APPEND CMAKE_MODULE_PATH ${boostorg_cmake_SOURCE_DIR}/include)

  # Enable testing

  include(CTest)
  add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure -C $<CONFIG>)

  if(BUILD_TESTING)

    set(BUILD_TESTING OFF) # hide cache variable

    boost_fetch(boostorg/assert TAG develop EXCLUDE_FROM_ALL)
    boost_fetch(boostorg/config TAG develop EXCLUDE_FROM_ALL)
    boost_fetch(boostorg/core TAG develop EXCLUDE_FROM_ALL)
    boost_fetch(boostorg/mp11 TAG develop EXCLUDE_FROM_ALL)
    boost_fetch(boostorg/throw_exception TAG develop EXCLUDE_FROM_ALL)
    boost_fetch(boostorg/variant2 TAG develop EXCLUDE_FROM_ALL)
    ## No cmake support yet
    # boost_fetch(boostorg/accumulators TAG develop)
    # boost_fetch(boostorg/range TAG develop)
    # boost_fetch(boostorg/serialization TAG develop)
    # boost_fetch(boostorg/units TAG develop)

    unset(BUILD_TESTING)

  endif()

endif()

if(BOOST_SUPERPROJECT_VERSION)

  include(BoostInstall)
  boost_install(TARGETS boost_histogram HEADER_DIRECTORY include/)

endif()

if (BUILD_TESTING)

  add_subdirectory(test)

  # do not pollute the superproject with the benchmarks
  if(NOT BOOST_SUPERPROJECT_VERSION)

    add_subdirectory(benchmark)

  endif()

endif()

=== src/test/crimson/seastore/onode_tree/CMakeLists.txt ===
add_executable(test-seastore-onode-tree-node
  test_node.cc)
add_ceph_unittest(test-seastore-onode-tree-node)
target_link_libraries(test-seastore-onode-tree-node
  crimson-seastore
  GTest::Main)

add_executable(unittest-staged-fltree
  test_staged_fltree.cc
  ../../gtest_seastar.cc)
add_ceph_unittest(unittest-staged-fltree)
target_link_libraries(unittest-staged-fltree
  crimson-seastore)

=== debian/control ===
Source: ceph
Section: admin
Priority: optional
Homepage: http://ceph.com/
Vcs-Git: git://github.com/ceph/ceph.git
Vcs-Browser: https://github.com/ceph/ceph
Maintainer: Ceph Maintainers <ceph-maintainers@lists.ceph.com>
Uploaders: Ken Dreyer <kdreyer@redhat.com>,
           Alfredo Deza <adeza@redhat.com>,
Build-Depends: automake,
# Jaeger       bison,
               cmake (>= 3.10.2),
               cpio,
               cryptsetup-bin | cryptsetup,
               cython,
               cython3,
               debhelper (>= 9),
               default-jdk,
               dh-exec,
               dh-python,
               dh-systemd,
# Jaeger       flex,
               git,
               gperf,
               g++ (>= 7),
               javahelper,
# Make-Check   jq,
               junit4,
               libaio-dev,
               libbabeltrace-ctf-dev,
               libbabeltrace-dev,
               libblkid-dev (>= 2.17),
# Crimson      libc-ares-dev,
# Crimson      libcrypto++-dev,
               libcryptsetup-dev,
               libcap-ng-dev,
               libcunit1-dev,
               libcurl4-openssl-dev,
# Jaeger       libevent-dev,
               libexpat1-dev,
# Make-Check   libffi-dev [!amd64],
               libfuse-dev,
               libgoogle-perftools-dev [i386 amd64 arm64],
# Crimson      libgnutls28-dev,
# Crimson      libhwloc-dev,
               libibverbs-dev,
               libicu-dev,
               librdmacm-dev,
               libkeyutils-dev,
               libldap2-dev,
               libleveldb-dev,
               liblttng-ust-dev,
               liblua5.3-dev,
               liblz4-dev (>= 0.0~r131),
               libncurses-dev,
               libnss3-dev,
               liboath-dev,
# Crimson      libnuma-dev,
# Crimson      libpciaccess-dev,
# Crimson      libprotobuf-dev,
# Crimson      libsctp-dev,
               libsnappy-dev,
               libsqlite3-dev,
               libssl-dev,
               libtool,
               libudev-dev,
               libnl-genl-3-dev,
               libxml2-dev,
               librabbitmq-dev,
               librdkafka-dev,
               luarocks,
# Make-Check   libxmlsec1,
# Make-Check   libxmlsec1-nss,
# Make-Check   libxmlsec1-openssl,
# Make-Check   libxmlsec1-dev,
# Crimson      libyaml-cpp-dev,
               lsb-release,
# Jaeger       nlohmann-json-dev | nlohmann-json3-dev,
               parted,
               patch,
               pkg-config,
# Crimson      protobuf-compiler,
               python3-all-dev,
               python3-cherrypy3,
# Make-Check   python3-jwt,
# Make-Check   python3-nose,
# Make-Check   python3-pecan,
# Make-Check   python3-bcrypt,
# Make-Check   tox,
# Make-Check   python3-coverage,
# Make-Check   python3-dateutil,
# Make-Check   python3-openssl,
# Make-Check   python3-prettytable,
# Make-Check   python3-requests,
# Make-Check   python3-scipy,
               python3-setuptools,
               python3-sphinx,
# Make-Check   python3-werkzeug,
               python3-setuptools,
# Crimson      ragel,
# Make-Check   socat,
# Crimson      systemtap-sdt-dev,
# Make-Check   uuid-dev,
               uuid-runtime,
               valgrind,
               virtualenv,
               xfslibs-dev,
# Make-Check   xfsprogs,
# Make-Check   xmlstarlet,
               nasm [amd64],
               zlib1g-dev,
# Jaeger       Built-Using:   libyaml-cpp-dev (>= 0.6),
Standards-Version: 4.4.0

Package: ceph
Architecture: linux-any
Depends: ceph-mgr (= ${binary:Version}),
         ceph-mon (= ${binary:Version}),
         ceph-osd (= ${binary:Version}),
Recommends: ceph-mds (= ${binary:Version}),
Description: distributed storage and file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.

Package: ceph-base
Architecture: linux-any
Depends: binutils,
         ceph-common (= ${binary:Version}),
         cryptsetup-bin | cryptsetup,
         debianutils,
         e2fsprogs,
         findutils,
         grep,
         logrotate,
         parted,
         psmisc,
         xfsprogs,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
Recommends: btrfs-tools,
            ceph-mds (= ${binary:Version}),
            librados2 (= ${binary:Version}),
            libradosstriper1 (= ${binary:Version}),
            librbd1 (= ${binary:Version}),
            ntp | time-daemon,
Replaces: ceph (<< 10),
          ceph-common (<< 0.78-500),
          ceph-test (<< 12.2.2-14),
          python-ceph (<< 0.92-1223),
Breaks: ceph (<< 10),
        ceph-test (<< 12.2.2-14),
        python-ceph (<< 0.92-1223),
Description: common ceph daemon libraries and management tools
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the libraries and management tools that are common among
 the Ceph server daemons (ceph-mon, ceph-mgr, ceph-osd, ceph-mds). These tools
 are necessary for creating, running, and administering a Ceph storage cluster.

Package: ceph-base-dbg
Architecture: linux-any
Section: debug
Priority: extra
Depends: ceph-base (= ${binary:Version}),
         ${misc:Depends},
Description: debugging symbols for ceph-base
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the libraries and management tools that are common among
 the Ceph server daemons (ceph-mon, ceph-mgr, ceph-osd, ceph-mds). These tools
 are necessary for creating, running, and administering a Ceph storage cluster.
 .
 This package contains the debugging symbols for ceph-base.

Package: cephadm
Architecture: linux-any
Recommends: podman (>= 2.0.2) | docker.io
Depends: lvm2,
	 ${python:Depends},
Description: cephadm utility to bootstrap ceph daemons with systemd and containers
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 The cephadm utility is used to bootstrap a Ceph cluster and to manage
 ceph daemons deployed with systemd and containers.

Package: ceph-mds
Architecture: linux-any
Depends: ceph-base (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: ceph-fuse (= ${binary:Version}),
            libcephfs2 (= ${binary:Version}),
Replaces: ceph (<< 0.93-417),
Breaks: ceph (<< 0.93-417),
Description: metadata server for the ceph distributed file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the metadata server daemon, which is used to
 create a distributed file system on top of the ceph storage cluster.

Package: ceph-mds-dbg
Architecture: linux-any
Section: debug
Priority: extra
Depends: ceph-mds (= ${binary:Version}),
         ${misc:Depends},
Description: debugging symbols for ceph-mds
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the debugging symbols for ceph-mds.

Package: ceph-mgr
Architecture: linux-any
Depends: ceph-base (= ${binary:Version}),
         ceph-mgr-modules-core (= ${binary:Version}),
         libsqlite3-mod-ceph,
         python3-bcrypt,
         python3-cherrypy3,
         python3-distutils,
         python3-jwt,
         python3-openssl,
         python3-pecan,
         python3-requests,
         python3-werkzeug,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
Recommends: ceph-mgr-dashboard,
            ceph-mgr-diskprediction-local,
            ceph-mgr-k8sevents,
            ceph-mgr-cephadm
Suggests: python3-influxdb
Replaces: ceph (<< 0.93-417),
Breaks: ceph (<< 0.93-417),
Description: manager for the ceph distributed storage system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the manager daemon, which is used to expose high
 level management and monitoring functionality.

Package: ceph-mgr-dashboard
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
         python3-cherrypy3,
         python3-jwt,
         python3-bcrypt,
         python3-werkzeug,
         python3-routes,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
Description: dashboard module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package provides a ceph-mgr module, providing a web-based
 application to monitor and manage many aspects of a Ceph cluster and
 related components.
 .
 See the Dashboard documentation at http://docs.ceph.com/ for details
 and a detailed feature overview.

Package: ceph-mgr-diskprediction-local
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
         python3-numpy,
         python3-scipy,
         python3-sklearn,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
Description: diskprediction-local module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the diskprediction_local module for the ceph-mgr
 daemon, which helps predict disk failures.

Package: ceph-mgr-modules-core
Architecture: all
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
         python3-dateutil,
         python3-openssl,
Replaces: ceph-mgr (<< 15.1.0)
Breaks: ceph-mgr (<< 15.1.0)
Recommends: ceph-mgr-rook
Description: ceph manager modules which are always enabled
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains a set of core ceph-mgr modules which are always
 enabled.

Package: ceph-mgr-rook
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
         python3-jsonpatch
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
Description: rook module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the rook module for ceph-mgr's orchestration
 functionality, to allow ceph-mgr to install and configure ceph using
 Rook.

Package: ceph-mgr-k8sevents
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
         python3-kubernetes,
         ${misc:Depends},
         ${python:Depends},
Description: kubernetes events module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the k8sevents module, to allow ceph-mgr to send
 ceph related events to the kubernetes events API, and track all events
 that occur within the rook-ceph namespace.

Package: ceph-mgr-cephadm
Architecture: all
Depends: ceph-mgr (= ${binary:Version}),
	 cephadm,
         ${misc:Depends},
         ${python:Depends},
         openssh-client,
         python3-jinja2
Description: cephadm orchestrator module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the CEPHADM module for ceph-mgr's orchestration
 functionality, to allow ceph-mgr to perform orchestration functions
 over a standard SSH connection.
